package com.apl.test;

import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLConnection;
import java.nio.charset.StandardCharsets;
import java.security.KeyManagementException;
import java.security.NoSuchAlgorithmException;
import java.security.cert.X509Certificate;
import java.util.List;
import java.util.Map;

import javax.net.ssl.HostnameVerifier;
import javax.net.ssl.HttpsURLConnection;
import javax.net.ssl.SSLContext;
import javax.net.ssl.SSLSession;
import javax.net.ssl.TrustManager;
import javax.net.ssl.X509TrustManager;

import com.apl.Functions;

public class CookieTest {

	private final static HostnameVerifier allHostsValid = new HostnameVerifier() {
		@Override
		public boolean verify(String hostname, SSLSession session) {
			return true;
		}
	};

	private final static TrustManager[] trustAllCerts = new TrustManager[] { new X509TrustManager() {
		@Override
		public void checkClientTrusted(X509Certificate[] certs, String authType) {
		}

		@Override
		public void checkServerTrusted(X509Certificate[] certs, String authType) {
		}

		@Override
		public java.security.cert.X509Certificate[] getAcceptedIssuers() {
			return null;
		}
	} };

	public static void main(String[] args) throws Exception {
		String urlS = "";
		urlS = "https://dummy.restapiexample.com/api/v1/employee/1";
		urlS = "https://gorest.co.in/public/v1/users";
		urlS = "https://jsonplaceholder.typicode.com/todos/3";
		urlS = "https://reqres.in/api/users/2";

		String method = "POST";
		boolean bypass = true;

		URL url = new URL(urlS);

		String body = "{\"user_name\":\"\", \"password\":\"\"}";

		if (url.toString().startsWith("https") && bypass) {
			try {
				SSLContext sc = SSLContext.getInstance("TLS");
				sc.init(null, trustAllCerts, new java.security.SecureRandom());
				HttpsURLConnection.setDefaultSSLSocketFactory(sc.getSocketFactory());
				HttpsURLConnection.setDefaultHostnameVerifier(allHostsValid);
			} catch (NoSuchAlgorithmException e) {
				String message = "NoSuchAlgorithmException while installing TrustManager: " + e.getMessage();
				System.out.println(message);
			} catch (KeyManagementException e) {
				String message = "KeyManagementException while installing TrustManager: " + e.getMessage();
				System.out.println(message);
			}
		}

		URLConnection conn = url.openConnection();
		((HttpURLConnection) conn).setRequestMethod(method);
		((HttpURLConnection) conn).addRequestProperty("Content-Type", "application/json");
		((HttpURLConnection) conn).setDoOutput(true);
		((HttpURLConnection) conn).setDoInput(true);

		OutputStream os = conn.getOutputStream();
		byte[] array = body.getBytes(StandardCharsets.UTF_8);
		os.write(array);

		Map<String, List<String>> headerMap = conn.getHeaderFields();

		for (String headerKey : headerMap.keySet()) {
			List<String> headerValueList = headerMap.get(headerKey);

			if ("Set-Cookie".equalsIgnoreCase(headerKey)) {

				for (String headerValue : headerValueList) {

					System.out.println("Cookie Found...");
					System.out.println(headerValue);

					String[] fields = headerValue.split(";");

					String cookieValue = fields[0].trim();
					String cookieName = cookieValue.substring(0, cookieValue.indexOf("="));
					cookieValue = cookieValue.substring(cookieValue.indexOf("=") + 1);

					String element = "Cookie-" + cookieName;
					System.out.println(element + " | " + cookieValue);

					// Parse each field
					for (int j = 1; j < fields.length; j++) {
						String v = fields[j].trim();
						if (v.contains("=")) {
							String s = element + "-" + v.substring(0, v.indexOf("="));
							String sv = v.substring(v.indexOf("=") + 1);
							System.out.println(s + " | " + sv);
						} else {
							String s = element + "-" + v;
							String sv = "true";
							System.out.println(s + " | " + sv);
						}
					}
					System.out.println("*****************************************");
				}
			} else {
				StringBuilder sb = new StringBuilder();
				if (headerValueList != null) {
					for (String headerValue : headerValueList) {
						if (sb.toString().isEmpty()) {
							sb.append(headerValue);
						} else {
							sb.append(",");
							sb.append(headerValue);
						}
					}
				}
				String headerValues = sb.toString();
				if (headerKey != null && !headerKey.isEmpty() && headerValues != null && !headerValues.isEmpty()) {
					System.out.println("HeaderKey|Value: " + headerKey + "|" + headerValues);
				}
			}
		}

		byte[] bytes = Functions.processInputStream(null, conn.getInputStream());
		String output = new String(bytes).trim();

		System.out.println(output);
	}

}