/*
	APL Restful ARDBC Plugin
    Copyright 2015-2018  LJ LongWing - A Programming Legacy (http://remedylegacy.com)

	Licensed under the Apache License, Version 2.0 (the "License");
	you may not use this file except in compliance with the License.
	You may obtain a copy of the License at

		http://www.apache.org/licenses/LICENSE-2.0

	Unless required by applicable law or agreed to in writing, software
	distributed under the License is distributed on an "AS IS" BASIS,
	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	See the License for the specific language governing permissions and
	limitations under the License.
*/

package com.apl.test;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import com.apl.Functions;
import com.apl.JSONParser;
import com.apl.RestfulARDBCPlugin;
import com.bmc.arsys.api.ARException;
import com.bmc.arsys.api.Entry;
import com.bmc.arsys.api.QualifierInfo;
import com.bmc.arsys.api.RelationalOperationInfo;
import com.bmc.arsys.api.Value;
import com.bmc.arsys.pluginsvr.plugins.ARVendorField;

public class JSONTest {
	public static void main(String[] args) {
		List<ARVendorField> vendorFieldList = new ArrayList<ARVendorField>();
		// vendorFieldList.add(new ARVendorField("ROOT:syntematized", 1234,
		// Constants.AR_DATA_TYPE_CHAR,
		// new CharacterFieldLimit(0, Constants.AR_MENU_APPEND,
		// Constants.AR_QBE_MATCH_EQUAL, "", "", 0)));
		// vendorFieldList.add(new ARVendorField("ROOT:streetId", 1235,
		// Constants.AR_DATA_TYPE_CHAR,
		// new CharacterFieldLimit(0, Constants.AR_MENU_APPEND,
		// Constants.AR_QBE_MATCH_EQUAL, "", "", 0)));
		// vendorFieldList.add(new ARVendorField("ROOT:systematized", 1236,
		// Constants.AR_DATA_TYPE_CHAR,
		// new CharacterFieldLimit(0, Constants.AR_MENU_APPEND,
		// Constants.AR_QBE_MATCH_EQUAL, "", "", 0)));
		// vendorFieldList.add(new ARVendorField("ROOT:type", 1237,
		// Constants.AR_DATA_TYPE_CHAR,
		// new CharacterFieldLimit(0, Constants.AR_MENU_APPEND,
		// Constants.AR_QBE_MATCH_EQUAL, "", "", 0)));
		// vendorFieldList.add(new ARVendorField("ROOT:zipcode", 1238,
		// Constants.AR_DATA_TYPE_INTEGER,
		// new IntegerFieldLimit(0, 1000)));
//		vendorFieldList.add(new ARVendorField("ROOT:Data:external_reference_id", -1, Constants.AR_DATA_TYPE_CHAR,
//				new CharacterFieldLimit(0, Constants.AR_MENU_APPEND, Constants.AR_QBE_MATCH_EQUAL, "", "", 0)));

		String fileName = "json.txt";
		InputStream is = null;
		JSONParser parser = null;
		try {
			is = new FileInputStream(new File(fileName));
			byte[] bytes = Functions.processInputStream(null, is);
			String output = new String(bytes);
			List<Integer> skipLevelList = new ArrayList<Integer>();
			// skipLevelList.add(1);

			parser = new JSONParser(vendorFieldList, "ROOT", -1, skipLevelList);
			parser.parse(output, ",");
		} catch (IOException e) {
			System.out.println("IOException: " + e.getMessage());
		} finally {
			if (is != null) {
				try {
					is.close();
				} catch (IOException e) {
					System.out.println("IOException: " + e.getMessage());
				}
			}
		}

		Map<String, String> globalElementMap = parser.getGlobalElementMap();
		List<Map<String, String>> recordElementList = parser.getRecordElementList();

		if (globalElementMap != null) {
			System.out.println("GlobalMap Size: " + globalElementMap.size());
		}
		if (recordElementList != null) {
			System.out.println("RecordMap Size: " + recordElementList.size());
		}

		if (globalElementMap != null) {
			for (String element : globalElementMap.keySet()) {
				String value = globalElementMap.get(element);
				System.out.println("GlobalMap: " + element + " - " + value);
			}
		}
		QualifierInfo qual = Functions.getQualifierInfo(1238, 1234, RelationalOperationInfo.AR_REL_OP_EQUAL);
		List<String> fieldLocalFilterList = new ArrayList<>();
		// fieldLocalFilterList.add("ROOT:zipcode");

		if (recordElementList != null) {
			for (Map<String, String> recordElementMap : recordElementList) {
				Entry entry = new Entry();
				for (String key : recordElementMap.keySet()) {
					int fieldId = -1;
					for (ARVendorField field : vendorFieldList) {
						if (field.getName().equals(key)) {
							fieldId = field.getFieldId();
							break;
						}
					}
					Value value = new Value(recordElementMap.get(key));
					try {
						value = new Value(Integer.valueOf(recordElementMap.get(key)));
					} catch (Exception e) {
					}

					entry.put(fieldId, value);
				}
				if (Functions.processLocalFilter(qual, vendorFieldList, fieldLocalFilterList, entry, null)) {
					RestfulARDBCPlugin restfulARDBCPlugin = new RestfulARDBCPlugin();
					try {
						restfulARDBCPlugin.initialize(null);
					} catch (ARException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
					restfulARDBCPlugin.manageCacheEntry(null, "JSONTest", null, "JSONTest", entry.getEntryId(), "Cache",
							"JSONTest", entry, "Add", false);
					System.out.println("Start Record");
					for (String element : recordElementMap.keySet()) {
						String value = recordElementMap.get(element);
						System.out.println("RecordMap: " + element + " - " + value);
					}
					System.out.println("End Record");
				} else {
					System.out.println("Record eliminated by Local Filter");
				}
			}
		}
	}
}
