package com.apl.test;

import com.apl.APLConstants;
import com.apl.Functions;
import com.bmc.arsys.api.ARException;
import com.bmc.arsys.api.ARServerUser;
import com.bmc.arsys.api.QualifierInfo;
import com.bmc.arsys.api.RelationalOperationInfo;

public class QualTest {

	public static void main(String[] args) throws ARException {
		String tableForm = "APL:RestfulVendorForms:Table";
		String tableName = "WikiMusicSearchXML"; 
		
		System.out.println("Connecting");
		ARServerUser conn = new ARServerUser("Demo", null, null, "192.168.1.106", 21500);
		conn.login();
		String qualS = "'Status' = \"Active\" AND 'Table' = \"" + tableName + "\"";
		System.out.println("Generating QualInfo");
		QualifierInfo qual1 = conn.parseQualification(tableForm, qualS);

		System.out.println("1: " + qual1);
		
		QualifierInfo tableQual = Functions.getQualifierInfo(APLConstants.fidTableName, tableName, RelationalOperationInfo.AR_REL_OP_EQUAL);
		QualifierInfo statusActiveQual = Functions.getQualifierInfo(APLConstants.fidStatus, 0, RelationalOperationInfo.AR_REL_OP_EQUAL);
		QualifierInfo qual2 = new QualifierInfo(QualifierInfo.AR_COND_OP_AND, statusActiveQual, tableQual);		
		System.out.println("2: " + qual2);

		System.out.println();
		System.out.println("Q1: " + tableQual);
		System.out.println("Q2: " + statusActiveQual);

		conn.getListEntryObjects(tableForm, Functions.getActiveTableQual(tableName), 0, 0, null, APLConstants.tableFields, false, null);
		
		System.out.println("Done");
	}

}
