/*
	APL Restful ARDBC Plugin
    Copyright 2015-2018  LJ LongWing - A Programming Legacy (http://remedylegacy.com)

	Licensed under the Apache License, Version 2.0 (the "License");
	you may not use this file except in compliance with the License.
	You may obtain a copy of the License at

		http://www.apache.org/licenses/LICENSE-2.0

	Unless required by applicable law or agreed to in writing, software
	distributed under the License is distributed on an "AS IS" BASIS,
	WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
	See the License for the specific language governing permissions and
	limitations under the License.
*/

package com.apl.test;

import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import com.apl.XMLParser;
import com.bmc.arsys.pluginsvr.plugins.ARVendorField;

public class XMLTest {
	public static void main(String[] args) throws Exception {
		List<ARVendorField> vendorFieldList = new ArrayList<ARVendorField>();

		SAXParserFactory factory = SAXParserFactory.newInstance();
		List<Integer> skipLevels = new ArrayList<>();
		XMLParser handler = new XMLParser("CustCircuitResponse:CircuitList", skipLevels, vendorFieldList);

		File initialFile = new File("xml.txt");
		InputStream is = new FileInputStream(initialFile);

		SAXParser parser = factory.newSAXParser();

		parser.parse(is, handler);

		Map<String, String> globalElementMap = handler.getGlobalElementMap(",");
		if (globalElementMap != null) {
			for (String element : globalElementMap.keySet()) {
				String value = globalElementMap.get(element);
				System.out.println("GlobalMap: " + element + " - " + value);
			}
		}
		List<Map<String, String>> recordElementList = handler.getRecordElementList();
		if (recordElementList != null) {
			for (Map<String, String> recordElementMap : recordElementList) {
				System.out.println("Start Record");
				for (String element : recordElementMap.keySet()) {
					String value = recordElementMap.get(element);
					System.out.println("RecordMap: " + element + " - " + value);
				}
				System.out.println("End Record");
			}
		}
	}
}
